
/*
information about a xlist


	l = xlist()

	l.__tag__ <- old style

	l.__tag__
	l.__uri__
	l.__attrs__
	l.__items__
	
	l.__dfa__
	l.
*/		
#ifndef Py_XLISTINFO_H
#define Py_XLISTINFO_H

#include <Python.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	PyObject_HEAD
	PyObject* tag;
	PyObject* uri;
	PyObject* prefix;
	PyObject* attrs_types;
	PyObject* required_attrs;
	PyObject* default_attrs;
	PyObject* none_attrs;
	PyObject* items_dfa;
} PyXListInfo;


extern void initxlistinfo();

extern PyObject* PyXListInfo_New();
extern PyObject* PyXListInfo_ForXList();
extern PyObject* PyXListInfo_GetDatatype(PyXListInfo* tpinfo, PyObject* key);

extern int PyXListInfo_InitValidation(PyXListInfo* self, PyTypeObject* type);
extern PyXListInfo* PyXListInfo_FromType(PyTypeObject* type);
extern DL_IMPORT(PyTypeObject) PyXListInfo_Type;

#define PyXListInfo_Check(op) PyObject_TypeCheck(op, &PyXListInfo_Type)
#define PyXListInfo_CheckExact(op) ((op)->ob_type == &PyXListInfo_Type)

#ifdef __cplusplus
}
#endif
#endif /* !Py_LISTOBJECT_H */
