
#ifndef _xquery_h_
#define _xquery_h_

#include <Python.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	PyObject* pattern;
	PyObject* params;
} QueryInfo;

typedef struct {
	PyObject* iterators[256];
	PyObject* query_nodes[256];
	PyObject* xlist;
	PyObject* params;
	int deep;
} QueryStatus;

extern PyObject* xquery_compile(PyObject* expression);
extern PyObject* xquery_next(PyObject* item, PyObject* last);
extern QueryInfo* xquery_compile_q(PyObject* query);
extern QueryStatus* xquery_init_iter(PyObject* xlist, PyObject* query_expr);
extern PyObject* xquery_iter(QueryStatus* status);
extern PyObject* xquery_query(QueryInfo* query,  QueryStatus* status);
extern PyObject* xquery_visit(PyObject* xlist, PyObject* items);
extern PyObject* xquery_next(PyObject* item, PyObject* last);
extern int xquery_iter_tell(QueryStatus* status, int deep);
extern void xquery_iter_seek(QueryStatus* status, int deep, int index, int clear);
extern void xquery_free_iter(QueryStatus* status);

extern void initxquery();

#ifdef __cplusplus
}
#endif
#endif
