import satine
from satine import dt
from satine import xlist, xspace
import sys

class attributeUse(dt.string):
    __facets__ = """<xsd:enumeration value="required">
                    <xsd:enumeration value="prohibited">
                    <xsd:enumeration value="optional">"""

class whitespaceValue(dt.string):
    __facets__ = """<xsd:enumeration value="preserve">
                    <xsd:enumeration value="replace">
                    <xsd:enumeration value="collapse">"""

class qualify(dt.string):
    __facets__ = """<xsd:enumeration value="qualified">
                    <xsd:enumeration value="unqualified">"""

class unboundType(dt.string):
    __facets__ = """<xsd:enumeration value="unbounded">"""

class maxOccursType(dt.dtunion):
    __facets__ = "<xsd:dt.nonNegativeInteger><xsd:unboundType>"

class processContents(dt.string):
    enumeration =['lax','skip','strict']

class unionItemType(dt._list):
    __tag__ = "unionItemType"
    __facets__ = dt.QName
    
class schema(xlist):
    __attrs__ =  """<xsd:ID>id
                    <xsd:anyURI>targetNamespace
                    <xsd:token>version"""
    __items__ = """(<xsd:annotation>|<xsd:include>|<xsd:element>|<xsd:complexType>|
                    <xsd:simpleType>|<xsd:import>)*"""

class element(xlist):
    __attrs__ = """<xsd:boolean default="false">abstract
                   <xsd:string>default
                   <xsd:string>fixed
                   <xsd:ID>id
                   <xsd:maxOccursType default="1">maxOccurs
                   <xsd:nonNegativeInteger default="1">minOccurs
                   <xsd:NCName>name
                   <xsd:boolean default="false">nillable
                   <xsd:QName>ref
                   <xsd:QName>substitutionGroup
                   <xsd:QName>type"""
    __items__ = """(<xsd:annotation>|<xsd:complexType>|<xsd:simpleType>)*"""

class attribute(xlist):
    __attrs__ = """<xsd:string>default
                   <xsd:string>fixed
                   <xsd:qualify>form
                   <xsd:ID>id
                   <xsd:NCName>name
                   <xsd:QName>ref
                   <xsd:QName>type
                   <xsd:attributeUse default="optional">use"""
    __items__ = """(<xsd:annotation>|<xsd:simpleType>)*"""
    
class attributeGroup(xlist):
    __attrs__ = """<xsd:ID>id
                   <xsd:NCName>name
                   <xsd:QName>ref"""
    __items__ = """(<xsd:annotation>|<xsd:attribute>|<xsd:attributeGroup>|<xsd:anyAttribute>)*"""
    
    
class annotation(xlist):
    __attrs__ = """<xsd:ID>id"""
    __items__ = """(<xsd:appinfo>|<xsd:documentation>)*"""

class documentation(xlist):
    __attrs__ = """<xsd:anyURI>source"""
    __items__ = """$"""
    
class appinfo(xlist):
    __attrs__ = """<xsd:anyURI>source"""
    __items__ = """"""

class complexType(xlist):
    __attrs__ = """<xsd:boolean default="false">abstract
                   <xsd:ID>id
                   <xsd:NCName>name
                   <xsd:boolean default="false">mixed"""
    __items__ = """(<xsd:annotation>|<xsd:simpleContent>|<xsd:complexContent>|
                   <xsd:group>|<xsd:all>|<xsd:choice>|<xsd:sequence>|
                   <xsd:attribute>|<xsd:attributeGroup>|<xsd:anyAttribute>)*"""

class group(xlist):
    __attrs__ = """<xsd:NCName>name"""
    __items__ = """(<xsd:annotation>|<xsd:all>|<xsd:choice>|<xsd:sequence>)*"""
    

class all(xlist):
    __attrs__ = """<xsd:ID>id
                   <xsd:maxOccursType default="1">maxOccurs
                   <xsd:nonNegativeInteger default="1">minOccurs"""
    __items__ = """(<xsd:annotation>|<xsd:element>|<xsd:choice>|<xsd:sequence>|
                   <xsd:any>|<xsd:group>)*"""


class choice(xlist):
    __attrs__ = """<xsd:ID>id
                   <xsd:maxOccursType default="1">maxOccurs
                   <xsd:nonNegativeInteger default="1">minOccurs"""
    __items__ = """(<xsd:annotation>|<xsd:element>|<xsd:choice>|<xsd:sequence>|
                   <xsd:any>|<xsd:group>)*"""

class sequence(xlist):
    __attrs__ = """<xsd:ID>id
                   <xsd:maxOccursType default="1">maxOccurs
                   <xsd:nonNegativeInteger default="1">minOccurs"""
    __items__ = """(<xsd:annotation>|<xsd:element>|<xsd:choice>|<xsd:sequence>|
                   <xsd:any>|<xsd:group>)*"""

class simpleType(xlist):
    __attrs__ = """<xsd:ID>id
                   <xsd:NCName>name"""
    __items__ = """(<xsd:annotation>|<xsd:restriction>|<xsd:list>|<xsd:union>)*"""
    

class restriction(xlist):
    __attrs__ = """<xsd:ID>id
                   <xsd:QName>base"""
    __items__ = """(<xsd:annotation>|<xsd:simpleType>|<xsd:minExclusive>|<xsd:minInclusive>|
                    <xsd:maxInclusive>|<xsd:totalDigits>|<xsd:fractionDigits>|
                    <xsd:length>|<xsd:minLenght>|<xsd:maxLenght>|<xsd:enumeration>|
                    <xsd:whitespace>|<xsd:pattern>)*"""

class extension(xlist):
    __attrs__ = """<xsd:ID>id
                   <xsd:QName>base"""
    __items__ = """<xsd:annotation>?(<xsd:attribute>|<xsd:attributeGroup>|
                    <xsd:choice>|<xsd:sequence>|<xsd:all>)*<xsd:anyAttribute>?"""

class any(xlist):
    __attrs__ =  """<xsd:ID>id
                    <xsd:maxOccursType default="1">maxOccurs
                    <xsd:nonNegativeInteger default="1">minOccurs
                    <xsd:string>namespace
                    <xsd:string defaut="strict">processContents"""
    __items__ = "<xsd:annotation>?"


class anyAttribute:
    __attrs__ =  """<xsd:ID>id
                    <xsd:string>namespace
                    <xsd:string defaut="strict">processContents"""
    __items__ = "<xsd:annotation>?"
    
class _import(xlist):
    __tag__ = "import"
    __attrs__ = """<xsd:string>namespace
                   <xsd:anyURI>schemaLocation"""
    __items__ = "<xsd:annotation>?"

class include(xlist):
    __attrs__ = """<xsd:ID>id
                   <xsd:anyURI>schemaLocation"""
    __items__ = "<xsd:annotation>?"
    

class simpleContent(xlist):
    __attrs__ = """<xsd:ID>id"""
    __items__ = """<xsd:annotation>?(<xsd:restriction>|<xsd:extension>)"""

class complexContent(xlist):
    __attrs__ = """<xsd:ID>id
                   <xsd:boolean>mixed"""
    __items__ = """<xsd:annotation>?(<xsd:restriction>|<xsd:extension>)"""


xspace(xsd = "http://www.w3.org/2001/XMLSchema")


