import odbc
import unittest
from satine import stream
from satine import db
import satine
import os

def fullname(filename):
    testpath = satine.test.__path__[0]
    return testpath+os.sep+filename

def openfile(filename):
    testpath = satine.test.__path__[0]
    filename = testpath+os.sep+filename
    return open(filename, "rb")    

class Repository(unittest.TestCase):

    def setUp(self):
        try:
            self.db = odbc.odbc("satine_dbtest")
        except:
            self.db = None
            return
        
    	rep = db.repository(self.db, surname="<person>|surname")
    	rep.create()

    def testReadAndWrite(self):
        if not self.db:
            return
        data = stream.file2py(fullname('addressbook1.xml'))
    	rep = db.repository(self.db, surname="<person>|surname")
    	rep.create()
    	for person in data:
            rep.put(person)

        self.assertEqual(rep.get(surname="Tolvald")[0], data[1])
        self.assertEqual(rep.get(surname="Eco")[0], data[3])
        self.assertNotEqual(rep.get(surname="Eco")[0], data[2])

    def testUpdate(self):
        if not self.db:
            return
        data = stream.file2py(fullname('addressbook1.xml'))
        data[1].name = "Linux"
    	rep = db.repository(self.db, surname="<person>|surname")
    	rep.create()
    	for person in data:
            rep.put(person)

        self.assertEqual(rep.get(surname="Tolvald")[0], data[1])
        data[1].name = "Linus"
        self.assertNotEqual(rep.get(surname="Tolvald")[0], data[1])

        rep.update(data[1], surname="Tolvald")
        self.assertEqual(rep.get(surname="Tolvald")[0], data[1])



if __name__ == "__main__":
    unittest.main()    